Index: dia/dia-0.88.1/lib/text.c
diff -u dia/dia-0.88.1/lib/text.c:1.1.1.1 dia/dia-0.88.1/lib/text.c:1.2.4.1
--- dia/dia-0.88.1/lib/text.c:1.1.1.1	Mon Sep 24 10:42:06 2001
+++ dia/dia-0.88.1/lib/text.c	Sun Oct 14 02:18:44 2001
@@ -55,6 +55,100 @@
 static ObjectChange *text_create_change(Text *text, enum change_type type,
 					char ch, int pos, int row);
 
+#ifdef USE_I18N
+static int
+text_string_length(const char *text) {
+  GdkWChar *wc;
+  int wclen;
+
+  wc = (GdkWChar *)g_malloc(sizeof(GdkWChar) * strlen(text));
+  wclen = gdk_mbstowcs(wc, text, strlen(text));
+
+  g_free(wc);
+  return wclen;
+}
+static int
+text_substring_length(const char *srctext, int pos) {
+  /* retrun the substring length, text(0,pos). */
+  char *text;
+  GdkWChar *wc;
+  int wclen;
+
+  if (pos < 0) {
+    return 0;
+  }
+  if (pos > strlen(srctext)) {
+    return strlen(srctext) - 1;
+  }
+
+  text = g_new(char, pos+1);
+
+  strncpy(text, srctext, pos);
+  text[pos] = '\0';
+
+  wc = g_new(GdkWChar, pos + 1);
+  /*
+  while((wclen = gdk_mbstowcs(wc, text, pos+1)) < 0) {
+    fprintf(stderr, "text_substring_length: (inc) wclen = %d\n", wclen);
+  }
+  */
+  wclen = gdk_mbstowcs(wc, text, pos+1);
+
+  g_free(wc);
+  g_free(text);
+
+  return wclen;
+}
+static int
+text_mbchar_length(const char *text, int pos, int direc) {
+  GdkWChar *wc;
+  int subwclen;
+  char *s,*e;
+  int start_pos, end_pos;
+
+  if (direc) { /* direc != 0 means to return the right side char size */
+    if (pos >= strlen(text)) {
+      return 1;
+    }
+  } else {
+      if (pos <= 0) {
+	return 1;
+      }
+  }
+
+  wc = g_new(GdkWChar, strlen(text)+1);
+  gdk_mbstowcs(wc, text, strlen(text)+1);
+
+  while((subwclen = text_substring_length(text, pos)) < 0) {
+    pos--;
+  }
+
+  if (direc) { /* to measure right side char size */
+    wc[subwclen+1] = '\0';
+    s = gdk_wcstombs(wc);
+    start_pos = strlen(s);
+
+    wc[subwclen] = '\0';
+    e = gdk_wcstombs(wc);
+    end_pos = strlen(e);
+  } else {
+    wc[subwclen] = '\0';
+    s = gdk_wcstombs(wc);
+    start_pos = strlen(s);
+
+    wc[subwclen-1] = '\0';
+    e = gdk_wcstombs(wc);
+    end_pos = strlen(e);
+  }
+
+  g_free(s);
+  g_free(e);
+  g_free(wc);
+
+  return start_pos - end_pos;
+}
+#endif
+
 static void
 calc_width(Text *text)
 {
@@ -98,6 +192,14 @@
 
   g_free(text->row_width);
   text->row_width = NULL;
+
+#ifdef USE_I18N
+  for (i=0;i<text->numlines;i++) {
+    g_free(text->wcline[i]);
+  }
+  g_free(text->wcline);
+  text->wcline = NULL;
+#endif
 }
 
 static void
@@ -122,12 +224,19 @@
   text->strlen = g_malloc(sizeof(int)*numlines);
   text->alloclen = g_malloc(sizeof(int)*numlines);
   text->row_width = g_malloc(sizeof(real)*numlines);
+#ifdef USE_I18N
+  text->wcline = g_malloc(sizeof(GdkWChar *)*numlines);
+#endif
 
   s = string;
 
   if (string==NULL) {
     text->line[0] = (char *)g_malloc(1);
     text->line[0][0] = 0;
+#ifdef USE_I18N
+    text->wcline[0] = g_new(GdkWChar, 1);
+    text->wcline[0][0] = 0;
+#endif
     text->strlen[0] = 0;
     text->alloclen[0] = 1;
     return;
@@ -145,6 +254,11 @@
     text->alloclen[i] = len+1;
     strncpy(text->line[i], s, len);
     text->line[i][len] = 0; /* end line with \0 */
+#ifdef USE_I18N
+    text->wcline[i] = g_new(GdkWChar, len+1);
+    text->cursor_real_pos = gdk_mbstowcs(text->wcline[i], s, len);
+    text->wcline[i][len] = 0;
+#endif
     s = s2+1;
   }
 
@@ -185,6 +299,9 @@
 
   text->cursor_pos = 0;
   text->cursor_row = 0;
+#ifdef USE_I18N
+  text->cursor_real_pos = 0;
+#endif
   
   text->focus.obj = NULL;
   text->focus.has_focus = FALSE;
@@ -211,12 +328,20 @@
   copy->strlen = g_malloc(sizeof(int)*copy->numlines);
   copy->alloclen = g_malloc(sizeof(int)*copy->numlines);
   copy->row_width = g_malloc(sizeof(real)*copy->numlines);
+#ifdef USE_I18N
+  copy->wcline = g_malloc(sizeof(GdkWChar *)*copy->numlines);
+#endif
   
   for (i=0;i<text->numlines;i++) {
     copy->line[i] = (char *)g_malloc(text->strlen[i]+1);
     strcpy(copy->line[i], text->line[i]);
     copy->strlen[i] = text->strlen[i];
     copy->alloclen[i] = text->strlen[i]+1;
+#ifdef USE_I18N
+    copy->wcline[i] = (GdkWChar *)g_malloc(sizeof(GdkWChar)*(text->strlen[i]+1));
+    copy->cursor_real_pos = gdk_mbstowcs(text->wcline[i], text->line[i], text->strlen[i]);
+    copy->wcline[i][copy->cursor_real_pos] = 0;
+#endif
   }
   
   copy->font = text->font;
@@ -512,6 +637,13 @@
       renderer->interactive_ops->get_text_width(renderer, text->line[row], i);
     if (clicked_point->x - start_x >= str_width_first) {
       text->cursor_pos = i;
+#ifdef USE_I18N
+      /* is it right? */
+      while(text_substring_length(text->line[text->cursor_row], 
+				  text->cursor_pos) < 0) {
+	text->cursor_pos--;
+      }
+#endif
     } else {
       return;
     }
@@ -574,6 +706,44 @@
 static void
 text_delete_forward(Text *text)
 {
+#ifdef USE_I18N
+  int row;
+  int i;
+  real width;
+  GdkWChar *wc;
+  int wclen;
+  
+  row = text->cursor_row;
+  
+  if (text->cursor_pos >= text->strlen[row]) {
+    if (row+1 < text->numlines)
+      text_join_lines(text, row);
+    return;
+  }
+  wc = g_new(GdkWChar, strlen(text->line[row])+1);
+  wclen = gdk_mbstowcs(wc, text->line[row], text_string_length(text->line[row]));
+  text->cursor_real_pos = text_substring_length(text->line[row], text->cursor_pos);
+  g_memmove(wc + text->cursor_real_pos,
+	    wc + text->cursor_real_pos + 1,
+	    (wclen - text->cursor_real_pos) * sizeof(GdkWChar));
+  wc[wclen-1] = '\0';
+
+  g_free(text->line[row]);
+  text->line[row] = gdk_wcstombs(wc);
+  text->strlen[row] = strlen(text->line[row]);
+  
+  if (text->cursor_pos > text->strlen[text->cursor_row])
+    text->cursor_pos = text->strlen[text->cursor_row];
+
+  text->row_width[row] = font_string_width(text->line[row], text->font, text->height);
+  width = 0.0;
+  for (i=0;i<text->numlines;i++) {
+    width = MAX(width, text->row_width[i]);
+  }
+  text->max_width = width;
+
+  g_free(wc);
+#else
   int row;
   int i;
   real width;
@@ -600,6 +770,7 @@
     width = MAX(width, text->row_width[i]);
   }
   text->max_width = width;
+#endif
 }
 
 static void
@@ -608,6 +779,11 @@
   int row;
   int i;
   real width;
+#ifdef USE_I18N
+  GdkWChar *wc;
+  gint wclen;
+  gint textlen;
+#endif
   
   row = text->cursor_row;
   
@@ -616,6 +792,23 @@
       text_join_lines(text, row-1);
     return;
   }
+#ifdef USE_I18N
+  textlen = strlen(text->line[row]);
+  wc = g_new(GdkWChar, strlen(text->line[row])+1);
+  wclen = gdk_mbstowcs(wc, text->line[row], text_string_length(text->line[row]));
+  text->cursor_real_pos = text_substring_length(text->line[row], text->cursor_pos);
+  g_memmove(wc + text->cursor_real_pos - 1,
+	    wc + text->cursor_real_pos,
+	    (wclen - text->cursor_real_pos) * sizeof(GdkWChar));
+  wc[wclen-1] = '\0';
+
+  g_free(text->line[row]);
+  text->line[row] = gdk_wcstombs(wc);
+  text->strlen[row] = strlen(text->line[row]);
+
+  /* if delete a single byte, text->cursor_pos -= 1; */
+  text->cursor_pos -= textlen - text->strlen[row]; 
+#else
   memmove(text->line[row] + text->cursor_pos - 1,
 	  text->line[row] + text->cursor_pos,
 	  text->strlen[row] - text->cursor_pos + 1);
@@ -623,6 +816,7 @@
   text->strlen[row]--;
 
   text->cursor_pos --;
+#endif
   
   if (text->cursor_pos > text->strlen[text->cursor_row])
     text->cursor_pos = text->strlen[text->cursor_row];
@@ -743,6 +937,12 @@
     if (text->cursor_row<0)
       text->cursor_row = 0;
 
+#ifdef USE_I18N
+    while(text_substring_length(text->line[text->cursor_row], 
+			    text->cursor_pos) < 0) {
+      text->cursor_pos--;
+    }
+#endif
     if (text->cursor_pos > text->strlen[text->cursor_row])
       text->cursor_pos = text->strlen[text->cursor_row];
 
@@ -752,17 +952,33 @@
     if (text->cursor_row >= text->numlines)
       text->cursor_row = text->numlines - 1;
 
+#ifdef USE_I18N
+    while(text_substring_length(text->line[text->cursor_row], 
+			    text->cursor_pos) < 0) {
+      text->cursor_pos--;
+    }
+#endif
     if (text->cursor_pos > text->strlen[text->cursor_row])
       text->cursor_pos = text->strlen[text->cursor_row];
     
     break;
   case GDK_Left:
+#ifdef USE_I18N
+    text->cursor_pos -= text_mbchar_length(text->line[text->cursor_row], 
+					   text->cursor_pos, 0);
+#else
     text->cursor_pos--;
+#endif
     if (text->cursor_pos<0)
       text->cursor_pos = 0;
     break;
   case GDK_Right:
+#ifdef USE_I18N
+    text->cursor_pos += text_mbchar_length(text->line[text->cursor_row], 
+					   text->cursor_pos, 1);
+#else
     text->cursor_pos++;
+#endif
     if (text->cursor_pos > text->strlen[text->cursor_row])
       text->cursor_pos = text->strlen[text->cursor_row];
     break;
Index: dia/dia-0.88.1/lib/text.h
diff -u dia/dia-0.88.1/lib/text.h:1.1.1.1 dia/dia-0.88.1/lib/text.h:1.2
--- dia/dia-0.88.1/lib/text.h:1.1.1.1	Mon Sep 24 10:42:06 2001
+++ dia/dia-0.88.1/lib/text.h	Sun Sep 30 15:00:22 2001
@@ -44,6 +44,10 @@
   int cursor_pos;
   int cursor_row;
   Focus focus;
+#ifdef USE_I18N
+  GdkWChar **wcline;
+  int cursor_real_pos;
+#endif
   
   /* Computed values:  */
   real ascent;
Index: dia/dia-0.88.1/objects/UML/class.c
diff -u dia/dia-0.88.1/objects/UML/class.c:1.1.1.1 dia/dia-0.88.1/objects/UML/class.c:1.2
--- dia/dia-0.88.1/objects/UML/class.c:1.1.1.1	Mon Sep 24 10:42:07 2001
+++ dia/dia-0.88.1/objects/UML/class.c	Sun Sep 30 15:00:22 2001
@@ -502,17 +502,29 @@
   }
   if (umlclass->stereotype != NULL) {
     umlclass->namebox_height += font_height;
+#ifdef USE_I18N
+    umlclass->stereotype_string =
+      g_malloc(sizeof(char)*(strlen(umlclass->stereotype)+4+1));
+
+    strncpy(umlclass->stereotype_string, UML_STEREOTYPE_START, 2);
+    umlclass->stereotype_string[2] = '\0';
+#else
     umlclass->stereotype_string =
       g_malloc(sizeof(char)*(strlen(umlclass->stereotype)+2+1));
     
     umlclass->stereotype_string[0] = UML_STEREOTYPE_START;
     umlclass->stereotype_string[1] = 0;
+#endif
     
     strcat(umlclass->stereotype_string, umlclass->stereotype);
 
+#ifdef USE_I18N
+    strncat(umlclass->stereotype_string, UML_STEREOTYPE_END, 2);
+#else
     i = strlen(umlclass->stereotype_string);
     umlclass->stereotype_string[i] = UML_STEREOTYPE_END;
     umlclass->stereotype_string[i+1] = 0;
+#endif
     
     width = font_string_width(umlclass->stereotype_string, umlclass->normal_font, font_height);
     maxwidth = MAX(width, maxwidth);
Index: dia/dia-0.88.1/objects/UML/object.c
diff -u dia/dia-0.88.1/objects/UML/object.c:1.1.1.1 dia/dia-0.88.1/objects/UML/object.c:1.2
--- dia/dia-0.88.1/objects/UML/object.c:1.1.1.1	Mon Sep 24 10:42:07 2001
+++ dia/dia-0.88.1/objects/UML/object.c	Sun Sep 30 15:00:22 2001
@@ -725,12 +725,21 @@
   str = gtk_entry_get_text(prop_dialog->stereotype);
   
   if (strlen(str) != 0) {
+#ifdef USE_I18N
+    ob->stereotype = g_malloc(sizeof(char)*strlen(str)+4+1);
+	strncpy(ob->stereotype, UML_STEREOTYPE_START, 2);
+#else /* !USE_I18N */
     ob->stereotype = g_malloc(sizeof(char)*strlen(str)+2+1);
     ob->stereotype[0] = UML_STEREOTYPE_START;
     ob->stereotype[1] = 0;
+#endif /* !USE_I18N */
     strcat(ob->stereotype, str);
+#ifdef USE_I18N
+    strncat(ob->stereotype, UML_STEREOTYPE_END, 2);
+#else /* !USE_I18N */
     ob->stereotype[strlen(str)+1] = UML_STEREOTYPE_END;
     ob->stereotype[strlen(str)+2] = 0;
+#endif /* !USE_I18N */
   } else {
     ob->stereotype = NULL;
   }
Index: dia/dia-0.88.1/objects/UML/stereotype.c
diff -u dia/dia-0.88.1/objects/UML/stereotype.c:1.1.1.1 dia/dia-0.88.1/objects/UML/stereotype.c:1.2
--- dia/dia-0.88.1/objects/UML/stereotype.c:1.1.1.1	Mon Sep 24 10:42:07 2001
+++ dia/dia-0.88.1/objects/UML/stereotype.c	Sun Sep 30 15:00:22 2001
@@ -47,8 +47,13 @@
   return str;
 }
 
+#ifdef USE_I18N
+char *uml_start_bracket = UML_STEREOTYPE_START;
+char *uml_end_bracket = UML_STEREOTYPE_END;
+#else
 char uml_start_bracket[] = {(char)UML_STEREOTYPE_START, '\0'};
 char uml_end_bracket[] = {(char)UML_STEREOTYPE_END, '\0'};
+#endif
 
 char *
 string_to_stereotype(char *str) {
@@ -57,6 +62,10 @@
 
 char *
 stereotype_to_string(char *stereotype) {
+#ifdef USE_I18N
+  return bracketted_to_string(stereotype, 2);
+#else /* !USE_I18N */
   return bracketted_to_string(stereotype, 1);
+#endif /* !USE_I18N */
 }
 
Index: dia/dia-0.88.1/objects/UML/uml.h
diff -u dia/dia-0.88.1/objects/UML/uml.h:1.1.1.1 dia/dia-0.88.1/objects/UML/uml.h:1.2
--- dia/dia-0.88.1/objects/UML/uml.h:1.1.1.1	Mon Sep 24 10:42:07 2001
+++ dia/dia-0.88.1/objects/UML/uml.h	Sun Sep 30 15:00:22 2001
@@ -77,8 +77,13 @@
 };
 
 /* Characters used to start/end stereotypes: */
+#ifdef USE_I18N
+#define UML_STEREOTYPE_START "<<"
+#define UML_STEREOTYPE_END ">>"
+#else
 #define UML_STEREOTYPE_START ((char) 171)
 #define UML_STEREOTYPE_END ((char) 187)
+#endif
 
 extern char *uml_get_attribute_string(UMLAttribute *attribute);
 extern char *uml_get_operation_string(UMLOperation *operation);
